package tech.sbdevelopment.vp3apitest.parts;

import nl.sbdeveloper.vehiclesplus.api.vehicles.HolderItemPosition;
import nl.sbdeveloper.vehiclesplus.api.vehicles.movement.MovementInput;
import nl.sbdeveloper.vehiclesplus.api.vehicles.parts.EquipablePart;
import nl.sbdeveloper.vehiclesplus.api.vehicles.parts.PartTypeName;
import nl.sbdeveloper.vehiclesplus.api.vehicles.parts.impl.seat.Controllable;
import nl.sbdeveloper.vehiclesplus.utils.ItemBuilder;
import org.bukkit.ChatColor;
import org.bukkit.Color;
import org.bukkit.Material;
import org.bukkit.inventory.ItemStack;

@PartTypeName("vent")
public class Vent extends EquipablePart implements Controllable {
    public Vent() {
        super(-0.3, 0.95, 0,
                new ItemBuilder(Material.LEATHER_CHESTPLATE)
                        .customModelData(4, (ib) -> ib
                                .durability((short) 4)
                                .unbreakable())
                        .armorColor(Color.GRAY)
                        .getItemStack(),
                HolderItemPosition.HEAD);
    }

    public Vent(double xOffset, double yOffset, double zOffset, ItemStack skin, HolderItemPosition position) {
        super(xOffset, yOffset, zOffset, skin, position);
    }

    @Override
    public ItemStack getPartGUIItem() {
        return new ItemBuilder(Material.LEATHER_BOOTS)
                .displayname(ChatColor.GOLD + "Vent")
                .lore(
                        ChatColor.GRAY + "This is the vent of the vehicle.",
                        ChatColor.GRAY + "It will provide a boost when the spacebar is pressed."
                )
                .unbreakable()
                .durability(7)
                .getItemStack();
    }

    @Override
    public String asString() {
        return "";
    }

    @Override
    public void handleInput(MovementInput movementInput) {
        if (movementInput.isSpace()) {
            holder.getVehicle().getVelocity().add(holder.getVehicle().getLocation().getDirection().multiply(0.5));
        }
    }
}
